# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import typing_extensions
from ..types.automations_get_response_data_status import AutomationsGetResponseDataStatus
from .automations_get_response_data_trigger import AutomationsGetResponseDataTriggerParams
from .automations_get_response_data_workflow_item import AutomationsGetResponseDataWorkflowItemParams


class AutomationsGetResponseDataParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the automation
    """

    name: str
    """
    User-defined name for the automation
    """

    description: typing_extensions.NotRequired[str]
    """
    Optional description for the automation
    """

    metadata: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    User-defined key-value metadata for the automation.
    """

    trigger: AutomationsGetResponseDataTriggerParams
    """
    The event and conditions that trigger this automation.
    """

    workflow: typing.Sequence[AutomationsGetResponseDataWorkflowItemParams]
    """
    The sequence of tasks to be executed when the automation is triggered. The structure of each task object varies depending on its 'kind'.
    """

    status: AutomationsGetResponseDataStatus
    """
    Current status of the automation
    """

    created: dt.datetime
    """
    Timestamp when the automation was created
    """

    updated: dt.datetime
    """
    Timestamp when the automation was last updated
    """
