# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import typing_extensions
from ..types.automations_update_response_data_status import AutomationsUpdateResponseDataStatus
from .automations_update_response_data_trigger import AutomationsUpdateResponseDataTriggerParams
from .automations_update_response_data_workflow_item import AutomationsUpdateResponseDataWorkflowItemParams


class AutomationsUpdateResponseDataParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the automation
    """

    name: str
    """
    User-defined name for the automation
    """

    description: typing_extensions.NotRequired[str]
    """
    Optional description for the automation
    """

    metadata: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    User-defined key-value metadata for the automation.
    """

    trigger: AutomationsUpdateResponseDataTriggerParams
    """
    The event and conditions that trigger this automation.
    """

    workflow: typing.Sequence[AutomationsUpdateResponseDataWorkflowItemParams]
    """
    The sequence of tasks to be executed when the automation is triggered. The structure of each task object varies depending on its 'kind'.
    """

    status: AutomationsUpdateResponseDataStatus
    """
    Current status of the automation
    """

    created: dt.datetime
    """
    Timestamp when the automation was created
    """

    updated: dt.datetime
    """
    Timestamp when the automation was last updated
    """
