# This file was auto-generated by Fern from our API Definition.

import typing

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from ..core.request_options import RequestOptions
from .raw_client import AsyncRawExampleClient, RawExampleClient
from .types.get_api_example_response import GetApiExampleResponse


class ExampleClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawExampleClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawExampleClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawExampleClient
        """
        return self._raw_client

    def example_endpoint(
        self, *, param: typing.Optional[str] = None, request_options: typing.Optional[RequestOptions] = None
    ) -> GetApiExampleResponse:
        """
        Parameters
        ----------
        param : typing.Optional[str]

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        GetApiExampleResponse
            Success

        Examples
        --------
        from ittybit import Ittybit
        client = Ittybit(token="YOUR_TOKEN", )
        client.example.example_endpoint()
        """
        _response = self._raw_client.example_endpoint(param=param, request_options=request_options)
        return _response.data


class AsyncExampleClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawExampleClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawExampleClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawExampleClient
        """
        return self._raw_client

    async def example_endpoint(
        self, *, param: typing.Optional[str] = None, request_options: typing.Optional[RequestOptions] = None
    ) -> GetApiExampleResponse:
        """
        Parameters
        ----------
        param : typing.Optional[str]

        request_options : typing.Optional[RequestOptions]
            Request-specific configuration.

        Returns
        -------
        GetApiExampleResponse
            Success

        Examples
        --------
        from ittybit import AsyncIttybit
        import asyncio
        client = AsyncIttybit(token="YOUR_TOKEN", )
        async def main() -> None:
            await client.example.example_endpoint()
        asyncio.run(main())
        """
        _response = await self._raw_client.example_endpoint(param=param, request_options=request_options)
        return _response.data
