# This file was auto-generated by Fern from our API Definition.

import datetime as dt

import typing_extensions
from ..types.task_workflow_item_kind import TaskWorkflowItemKind
from ..types.task_workflow_item_status import TaskWorkflowItemStatus


class TaskWorkflowItemParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the task.
    """

    object: str
    """
    Object type, always 'task'.
    """

    kind: TaskWorkflowItemKind
    """
    The type of operation the task performs.
    """

    status: TaskWorkflowItemStatus
    """
    Current status of the task.
    """

    progress: typing_extensions.NotRequired[int]
    """
    Task progress percentage.
    """

    error: typing_extensions.NotRequired[str]
    """
    Error message if the task failed.
    """

    created_by: typing_extensions.NotRequired[str]
    """
    ID of the entity that created the task (e.g., user ID, automation ID).
    """

    created: dt.datetime
    """
    Timestamp when the task was created.
    """

    updated: dt.datetime
    """
    Timestamp when the task was last updated.
    """

    parent_id: typing_extensions.NotRequired[str]
    """
    ID of the parent task if this is part of a workflow.
    """
