# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import typing_extensions
from ..types.tasks_get_response_data_kind import TasksGetResponseDataKind
from ..types.tasks_get_response_data_status import TasksGetResponseDataStatus
from .tasks_get_response_data_next_item import TasksGetResponseDataNextItemParams
from .tasks_get_response_data_results import TasksGetResponseDataResultsParams
from .tasks_get_response_data_workflow_item import TasksGetResponseDataWorkflowItemParams


class TasksGetResponseDataParams(typing_extensions.TypedDict):
    id: str
    """
    Unique identifier for the task.
    """

    object: str
    """
    Object type, always 'task'.
    """

    kind: TasksGetResponseDataKind
    """
    The type of operation the task performs.
    """

    input: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    The input source for the task (e.g., details of a file). Structure varies based on the task kind and preceding steps.
    """

    options: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    Configuration options specific to the task kind.
    """

    output: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    The result generated by the task (e.g., details of an output file or intelligence data). Structure varies.
    """

    status: TasksGetResponseDataStatus
    """
    Current status of the task.
    """

    progress: typing_extensions.NotRequired[int]
    """
    Task progress percentage.
    """

    error: typing_extensions.NotRequired[str]
    """
    Error message if the task failed.
    """

    created_by: typing_extensions.NotRequired[str]
    """
    ID of the entity that created the task (e.g., user ID, automation ID).
    """

    created: dt.datetime
    """
    Timestamp when the task was created.
    """

    updated: dt.datetime
    """
    Timestamp when the task was last updated.
    """

    parent_id: typing_extensions.NotRequired[str]
    """
    ID of the parent task if this is part of a workflow.
    """

    workflow: typing_extensions.NotRequired[typing.Sequence[TasksGetResponseDataWorkflowItemParams]]
    """
    Array of nested task objects representing the steps within this workflow task.
    """

    next: typing_extensions.NotRequired[typing.Sequence[TasksGetResponseDataNextItemParams]]
    """
    Array representing subsequent tasks (e.g., in an automation). Structure may vary.
    """

    results: typing_extensions.NotRequired[TasksGetResponseDataResultsParams]
